<?php

namespace Drupal\autoadress\Form;

use Drupal\autoadress\Constant\SettingConstants;
use Drupal\Core\Form\ConfigFormBase;
use Drupal\Core\Form\FormStateInterface;

/**
 * Settigs-Form.
 *
 * @package Drupal\autoadress\Form
 */
class AutoaddressSettings extends ConfigFormBase {

  /**
   * @inheritdoc
   */
  protected function getEditableConfigNames() {
    return [
      SettingConstants::AUTOADDRESS_SETTINGS,
    ];
  }

  /**
   * @inheritdoc
   */
  public function getFormId() {
    return 'autoaddress_settings_form';
  }

  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state) {
    $config = $this->config(SettingConstants::AUTOADDRESS_SETTINGS);

    // Cron-Läufe Titel.
    $form['description'] = [
      '#markup' => $this->t('Configuration restrict the countries for the addresssearch and to optionally configure the credential for Algolia Places.'),
    ];

    $form[SettingConstants::ALGOLIA_CREDENTIALS] = [
      '#type' => 'key_select',
      '#key_filters' => [
        'type' => 'user_password',
      ],
      '#title' => $this->t('App Credentials'),
      '#default_value' => $config->get(SettingConstants::ALGOLIA_CREDENTIALS),
      "#empty_option" => t('- Select -'),
    ];

    return parent::buildForm($form, $form_state);
  }

  /**
   *
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {
    parent::submitForm($form, $form_state);

    $this->config('autoaddress.settings')
      ->set(SettingConstants::ALGOLIA_CREDENTIALS, $form_state->getValue(SettingConstants::ALGOLIA_CREDENTIALS))
      ->save();
  }

}
